

using GLib;

namespace PeopleBackendDummyTest {

	public class ContactNew : PeopleBackendTest.Contact {
		private Gee.Set<PeopleBackend.Contact> contacts;

		protected override void initialize () {
			backend_name = "Dummy";
			contact_id = "foo-bar";
			contact_flags = PeopleBackend.ContactFlags.EDITABLE | PeopleBackend.ContactFlags.DELETABLE;

			base.initialize ();
		}

		protected override void set_up () {
			contacts = new Gee.HashSet<PeopleBackend.Contact> ();
			contact = new PeopleBackendDummy.Contact ("foo-bar", contacts);

			var fields = new Gee.HashMap<string, string>(str_hash, str_equal, str_equal);
			fields.set ("identity.name.first", "foo");
			fields.set ("identity.name.last", "bar");
			contact.set_fields(fields);

			contacts.add (contact);

			mandatory_fields.add ("identity.name.first");
			mandatory_fields.add ("identity.name.last");

			defined_fields.add ("identity.name.first");
			defined_fields.add ("identity.name.last");

			base.set_up ();
		}

		static int main(string[] args) {
			var suite = new ContactNew();
			return suite.run();
		}

	}
}
