using GLib;
using Gee;

namespace PeopleBackendKeyfileTest {

	public class ContactSourcePersistence : PeopleBackendTest.ContactSourcePersistence {
		protected override void initialize () {
			backend_name = "Keyfile";

			base.initialize ();
		}

		protected override void set_up () {
			contact_source_factory = new PeopleBackendKeyfile.ContactSourceFactory ();
			parameters = new Gee.HashMap<string, string> (str_hash, str_equal, str_equal);
			parameters.set ("file-path", "/tmp/people-test-contact-source-persistence-keyfile.ini");
			contact_source = contact_source_factory.request_contact_source (parameters);

			base.set_up ();
		}

		protected override void tear_down () {
			FileUtils.unlink (parameters.get ("file-path"));

			base.tear_down ();
		}

		static int main (string[] args) {
			var suite = new ContactSourcePersistence();
			return suite.run();
		}

	}
}
