

using GLib;

namespace PeopleBackendKeyfileTest {

	public class ContactNew : PeopleBackendTest.Contact {
		private KeyFile contacts;

		protected override void initialize () {
			backend_name = "Keyfile";
			contact_id = "foo-bar";
			contact_flags = PeopleBackend.ContactFlags.EDITABLE | PeopleBackend.ContactFlags.DELETABLE;

			base.initialize ();
		}

		protected override void set_up () {
			contacts = new KeyFile();
			contacts.set_string (contact_id, "communication.im.xmpp", "foo@bar.org");
			contacts.set_string (contact_id, "communication.phone.mobile", "+123");
			contacts.set_string (contact_id, "identity.name.last", "Bar");
			contacts.set_string (contact_id, "identity.name.first", "Foo");

			contact = new PeopleBackendKeyfile.Contact (contact_id, null, contacts);

			mandatory_fields.add ("identity.name.first");
			mandatory_fields.add ("identity.name.last");

			defined_fields.add ("identity.name.first");
			defined_fields.add ("identity.name.last");
			defined_fields.add ("communication.im.xmpp");
			defined_fields.add ("communication.phone.mobile");

			base.set_up ();
		}

		static int main(string[] args) {
			var suite = new ContactNew();
			return suite.run();
		}

	}
}
