

using GLib;

namespace PeopleBackendSqliteTest {

	public class ContactNew : PeopleBackendTest.Contact {
		private string db_path = "/tmp/people-test-sqlite-ab-saved.db";
		private Sqlite.Database db;

		protected override void initialize () {
			backend_name = "Sqlite";
			contact_id = "1";
			contact_flags = PeopleBackend.ContactFlags.EDITABLE | PeopleBackend.ContactFlags.DELETABLE;

			base.initialize ();
		}

		protected override void set_up () {
			Sqlite.Database.open(db_path, out db);
			db.exec (
				"CREATE TABLE IF NOT EXISTS people(" +
					"id integer PRIMARY KEY AUTOINCREMENT," +
					"first_name string," +
					"middle_name string," +
					"last_name string," +
					"home_phone string," +
					"work_phone string," +
					"mobile_phone string," +
					"home_email string," +
					"work_email string" +
				");");
			db.exec ("INSERT INTO people (first_name, last_name) VALUES (\"Foo\", \"Bar\")");

			contact = new PeopleBackendSqlite.Contact ("1", db);

			definable_fields.add ("identity.name.first");
			definable_fields.add ("identity.name.middle");
			definable_fields.add ("identity.name.last");
			definable_fields.add ("communication.phone.home");
			definable_fields.add ("communication.phone.work");
			definable_fields.add ("communication.phone.mobile");
			definable_fields.add ("communication.email.home");
			definable_fields.add ("communication.email.work");

			defined_fields.add ("identity.name.first");
			defined_fields.add ("identity.name.last");
			base.set_up ();
		}

		protected override void tear_down () {
			db = null;
			FileUtils.unlink (db_path);

			base.tear_down ();
		}

		static int main(string[] args) {
			var suite = new ContactNew();
			return suite.run();
		}

	}
}
