#!/usr/bin/env python

import dbus
from dbus.mainloop.glib import DBusGMainLoop
DBusGMainLoop(set_as_default=True)


import gobject
loop = gobject.MainLoop()

contacts_count = 0

def results_handler(results_count, sender=None):
	global contacts_count
	print "    Found %d results" % results_count
	contacts_count += results_count

def done_handler(sender=None):
	print "    Query finished"
	if contacts_count == 0:
		query_result.Close()
		loop.quit()
	else:
		get_contacts()


def get_contacts():
	global contacts_count
	print "    Getting %d contact(s)" % contacts_count
	contacts = query_result.GetPendingResults(dbus.UInt32(contacts_count))
	for object_path in contacts:
		contact = bus.get_object('net.launchpad.People', object_path)
		def defined_fields_retrieved(fields, sender=None):
			print "         Fields:", fields.split(" ")
			if sender is not None:
				contact.connect_to_signal("fields_retrieved", fields_retrieved, sender_keyword='sender')
				contact.RequestFields (fields)

		def fields_retrieved(fields, sender=None):
			print "         Fields values:", fields.split("\n")
		print "      - id:", contact.GetId()
		contact.connect_to_signal("defined_fields_retrieved",
			defined_fields_retrieved, sender_keyword='sender')
		contact.RequestDefinedFields ()
		break
	query_result.Close()
	#loop.quit()


bus = dbus.SessionBus()
people = bus.get_object('net.launchpad.People', '/net/launchpad/People')

address_books = people.ListAddressBooks()
print "Found the following address books"
for address_book_id in address_books:
	print "  *", address_book_id

print "\nRequesting the main address book:"
bus_name, object_path = people.RequestAddressBook("main")
print "  Got the main address book at", object_path
main_address_book = bus.get_object(bus_name, object_path)
print "  Querying the main address book"
query_result = bus.get_object(*main_address_book.Query("Dummy request"))

query_result.connect_to_signal("found_results", results_handler, sender_keyword='sender')
query_result.connect_to_signal("done", done_handler, sender_keyword='sender')

query_result.Open ()

loop.run ()
