using GLib;
using Gee;
using PeopleBackend;
using PeopleBackendHelper;


class AbstractContactStub : AbstractContact {
	public AbstractContactStub(string? id) {
		this.id = id;
	}

	public override AsyncOperation<Gee.Set<string> > get_defined_fields() {
		return new AsyncOperation<Gee.Set<string> > ();
	}

	public override AsyncOperation<Gee.Set<string> > get_definable_fields() {
		return new AsyncOperation<Gee.Set<string> > ();
	}

	public override AsyncOperation<Gee.Set<string> > get_mandatory_fields() {
		return new AsyncOperation<Gee.Set<string> > ();
	}

	public override AsyncOperation<ContactFieldSpec> get_field_spec(string field_name) {
		return new AsyncOperation<ContactFieldSpec> ();
	}

	public override AsyncOperation<Gee.Map<string, string> > get_fields(Gee.Set<string> fields) {
		return new AsyncOperation<Gee.Map<string, string> > ();
	}

	public override AsyncOperation<Gee.Set<string> > set_fields(Gee.Map<string, string> fields) {
		return new AsyncOperation<Gee.Set<string> > ();
	}

	public override AsyncOperation<bool> @delete() {
		return new AsyncOperation<bool> ();
	}

	public void do_set_id(string? id) {
		this.id = id;
	}
}

class AbstractContactSourceStub : AbstractContactSource {
	public override AsyncOperation<Contact> request_contact(string? id=null) {
		return new AsyncOperation<Contact> ();
	}

	public void do_bind_contact(Contact contact) {
		bind_contact(contact);
	}
}

private class TestAbstractContactSource {
	private static bool control = false;

	private static void contact_added_callback(ContactSource source, Contact contact) {
		control = !control;
	}

	private static void contact_removed_callback(ContactSource source, Contact contact) {
		control = !control;
	}

	public static int main (string[] args) {
		var tester = new SelfTest ("PeopleBackendHelper::AbstractContactSource testing");
		tester.start ();

		var source = new AbstractContactSourceStub();
		source.contact_added += contact_added_callback;
		source.contact_removed += contact_removed_callback;

		var contact = new AbstractContactStub(null);
		source.do_bind_contact(contact);

		var old_control = control;
		contact.do_set_id("other");
		tester.assert_false("checking added signal binding", old_control == control);

		old_control = control;
		contact.do_set_id(null);
		tester.assert_false("checking removed signal binding", old_control == control);

		if (tester.end ())
			return 0;
		return 1;
	}
}
